1 # This shell script fragment is sourced by git-rebase to implement
2 # its interactive mode. "git rebase --interactive" makes it easy
3 # to fix up commits in the middle of a series and rearrange commits.
5 # Copyright (c) 2006 Johannes E. Schindelin
7 # The original idea comes from Eric W. Biederman, in
8 # https://public-inbox.org/git/m1odwkyuf5.fsf_-_@ebiederm.dsl.xmission.com/
10 # The file containing rebase commands, comments, and empty lines.
11 # This file is created by "git rebase -i" then edited by the user. As
12 # the lines are processed, they are removed from the front of this
13 # file and written to the tail of $done.
14 todo
="$state_dir"/git-rebase-todo
16 # The rebase command lines that have already been processed. A line
17 # is moved here when it is first handled, before any associated user
19 done="$state_dir"/done
21 # The commit message that is planned to be used for any changes that
22 # need to be committed following a user interaction.
23 msg
="$state_dir"/message
25 # The file into which is accumulated the suggested commit message for
26 # squash/fixup commands. When the first of a series of squash/fixups
27 # is seen, the file is created and the commit message from the
28 # previous commit and from the first squash/fixup commit are written
29 # to it. The commit message for each subsequent squash/fixup commit
30 # is appended to the file as it is processed.
32 # The first line of the file is of the form
33 # # This is a combination of $count commits.
34 # where $count is the number of commits whose messages have been
35 # written to the file so far (including the initial "pick" commit).
36 # Each time that a commit message is processed, this line is read and
37 # updated. It is deleted just before the combined commit is made.
38 squash_msg
="$state_dir"/message-squash
40 # If the current series of squash/fixups has not yet included a squash
41 # command, then this file exists and holds the commit message of the
42 # original "pick" commit. (If the series ends without a "squash"
43 # command, then this can be used as the commit message of the combined
44 # commit without opening the editor.)
45 fixup_msg
="$state_dir"/message-fixup
47 # $rewritten is the name of a directory containing files for each
48 # commit that is reachable by at least one merge base of $head and
49 # $upstream. They are not necessarily rewritten, but their children
50 # might be. This ensures that commits on merged, but otherwise
51 # unrelated side branches are left alone. (Think "X" in the man page's
53 rewritten
="$state_dir"/rewritten
55 dropped
="$state_dir"/dropped
58 msgnum
="$state_dir"/msgnum
60 # A script to set the GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
61 # GIT_AUTHOR_DATE that will be used for the commit that is currently
63 author_script
="$state_dir"/author-script
65 # When an "edit" rebase command is being processed, the SHA1 of the
66 # commit to be edited is recorded in this file. When "git rebase
67 # --continue" is executed, if there are any staged changes then they
68 # will be amended to the HEAD commit, but only provided the HEAD
69 # commit is still the commit to be edited. When any other rebase
70 # command is processed, this file is deleted.
71 amend
="$state_dir"/amend
73 # For the post-rewrite hook, we make a list of rewritten commits and
74 # their new sha1s. The rewritten-pending list keeps the sha1s of
75 # commits that have been processed, but not committed yet,
76 # e.g. because they are waiting for a 'squash' command.
77 rewritten_list
="$state_dir"/rewritten-list
78 rewritten_pending
="$state_dir"/rewritten-pending
80 # Work around Git for Windows' Bash whose "read" does not strip CRLF
81 # and leaves CR at the end instead.
84 strategy_args
=${strategy:+--strategy=$strategy}
85 test -n "$strategy_opts" &&
87 for strategy_opt in '"$strategy_opts"'
89 strategy_args="$strategy_args -X$(git rev-parse --sq-quote "${strategy_opt#--}")"
93 GIT_CHERRY_PICK_HELP
="$resolvemsg"
94 export GIT_CHERRY_PICK_HELP
96 comment_char
=$
(git config
--get core.commentchar
2>/dev
/null
)
97 case "$comment_char" in
104 comment_char
=$
(echo "$comment_char" | cut
-c1)
109 printf '%s\n' "$*" >&2
112 # Output the commit message for the specified commit.
114 git cat-file commit
"$1" |
sed "1,/^$/d"
117 orig_reflog_action
="$GIT_REFLOG_ACTION"
119 comment_for_reflog
() {
120 case "$orig_reflog_action" in
122 GIT_REFLOG_ACTION
="rebase -i ($1)"
123 export GIT_REFLOG_ACTION
129 mark_action_done
() {
130 sed -e 1q
< "$todo" >> "$done"
131 sed -e 1d
< "$todo" >> "$todo".new
132 mv -f "$todo".new
"$todo"
133 new_count
=$
(( $
(git stripspace
--strip-comments <"$done" |
wc -l) ))
134 echo $new_count >"$msgnum"
135 total
=$
(($new_count + $
(git stripspace
--strip-comments <"$todo" |
wc -l)))
137 if test "$last_count" != "$new_count"
139 last_count
=$new_count
140 eval_gettext
"Rebasing (\$new_count/\$total)"; printf "\r"
141 test -z "$verbose" ||
echo
145 # Put the last action marked done at the beginning of the todo list
146 # again. If there has not been an action marked done yet, leave the list of
147 # items on the todo list unchanged.
148 reschedule_last_action
() {
149 tail -n 1 "$done" |
cat - "$todo" >"$todo".new
150 sed -e \
$d <"$done" >"$done".new
151 mv -f "$todo".new
"$todo"
152 mv -f "$done".new
"$done"
155 append_todo_help
() {
159 r, reword = use commit, but edit the commit message
160 e, edit = use commit, but stop for amending
161 s, squash = use commit, but meld into previous commit
162 f, fixup = like \"squash\", but discard this commit's log message
163 x, exec = run command (the rest of the line) using shell
164 d, drop = remove commit
166 These lines can be re-ordered; they are executed from top to bottom.
167 " | git stripspace
--comment-lines >>"$todo"
169 if test $
(get_missing_commit_check_level
) = error
172 Do not remove any line. Use 'drop' explicitly to remove a commit.
173 " | git stripspace
--comment-lines >>"$todo"
176 If you remove a line here THAT COMMIT WILL BE LOST.
177 " | git stripspace
--comment-lines >>"$todo"
182 sha1_and_parents
="$(git rev-list --parents -1 "$1")"
183 case "$sha1_and_parents" in
185 git
diff --cc $sha1_and_parents
188 git diff-tree
-p "$1^!"
193 esac > "$state_dir"/patch
195 commit_message
"$1" > "$msg"
196 test -f "$author_script" ||
197 get_author_ident_from_commit
"$1" > "$author_script"
201 echo "$1" > "$state_dir"/stopped-sha
202 git update-ref REBASE_HEAD
"$1"
208 echo "$1" > "$state_dir"/stopped-sha
209 git update-ref REBASE_HEAD
"$1"
211 git rev-parse
--verify HEAD
> "$amend"
212 gpg_sign_opt_quoted
=${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")}
213 warn
"$(eval_gettext "\
214 You can amend the commit now
, with
216 git commit
--amend \
$gpg_sign_opt_quoted
218 Once you are satisfied with your changes
, run
220 git rebase
--continue")"
232 test -n "$(git stripspace --strip-comments <"$1")"
236 tree
=$
(git rev-parse
-q --verify "$1"^
{tree
} 2>/dev
/null
) ||
{
238 die
"$(eval_gettext "\
$sha1: not a commit that can be picked
")"
240 ptree
=$
(git rev-parse
-q --verify "$1"^^
{tree
} 2>/dev
/null
) ||
241 ptree
=4b825dc642cb6eb9a060e54bf8d69288fbee4904
242 test "$tree" = "$ptree"
247 git rev-parse
--verify --quiet "$1"^
2 >/dev
/null
2>&1
250 # Run command with GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
251 # GIT_AUTHOR_DATE exported from the current environment.
254 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
259 git_sequence_editor
() {
260 if test -z "$GIT_SEQUENCE_EDITOR"
262 GIT_SEQUENCE_EDITOR
="$(git config sequence.editor)"
263 if [ -z "$GIT_SEQUENCE_EDITOR" ]
265 GIT_SEQUENCE_EDITOR
="$(git var GIT_EDITOR)" ||
return $?
269 eval "$GIT_SEQUENCE_EDITOR" '"$@"'
275 case "$1" in -n) sha1
=$2; ff
= ;; *) sha1
=$1 ;; esac
276 case "$force_rebase" in '') ;; ?
*) ff
= ;; esac
277 output git rev-parse
--verify $sha1 || die
"$(eval_gettext "Invalid commit name
: \
$sha1")"
279 if is_empty_commit
"$sha1"
281 empty_args
="--allow-empty"
284 test -d "$rewritten" &&
285 pick_one_preserving_merges
"$@" && return
286 output
eval git cherry-pick
$allow_rerere_autoupdate $allow_empty_message \
287 ${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")} \
288 $signoff "$strategy_args" $empty_args $ff "$@"
290 # If cherry-pick dies it leaves the to-be-picked commit unrecorded. Reschedule
291 # previous task so this commit is not lost.
293 case "$ret" in [01]) ;; *) reschedule_last_action
;; esac
297 pick_one_preserving_merges
() {
308 sha1
=$
(git rev-parse
$sha1)
310 if test -f "$state_dir"/current-commit
&& test "$fast_forward" = t
312 while read current_commit
314 git rev-parse HEAD
> "$rewritten"/$current_commit
315 done <"$state_dir"/current-commit
316 rm "$state_dir"/current-commit ||
317 die
"$(gettext "Cannot
write current commit
's replacement sha1")"
320 echo $sha1 >> "$state_dir"/current-commit
322 # rewrite parents; if none were rewritten, we can fast-forward.
324 pend=" $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)"
325 if test "$pend" = " "
329 while [ "$pend" != "" ]
331 p=$(expr "$pend" : ' \
([^
]*\
)')
334 if test -f "$rewritten"/$p
336 new_p=$(cat "$rewritten"/$p)
338 # If the todo reordered commits, and our parent is marked for
339 # rewriting, but hasn't been gotten to yet
, assume the user meant to
340 # drop it on top of the current HEAD
343 new_p
=$
(git rev-parse HEAD
)
346 test $p != $new_p && fast_forward
=f
347 case "$new_parents" in
349 ;; # do nothing; that parent is already there
351 new_parents
="$new_parents $new_p"
355 if test -f "$dropped"/$p
358 replacement
="$(cat "$dropped"/$p)"
359 test -z "$replacement" && replacement
=root
360 pend
=" $replacement$pend"
362 new_parents
="$new_parents $p"
366 case $fast_forward in
368 output warn
"$(eval_gettext "Fast-forward to \
$sha1")"
369 output git
reset --hard $sha1 ||
370 die
"$(eval_gettext "Cannot fast-forward to \
$sha1")"
373 first_parent
=$
(expr "$new_parents" : ' \([^ ]*\)')
377 # detach HEAD to current parent
378 output git checkout
$first_parent 2> /dev
/null ||
379 die
"$(eval_gettext "Cannot move HEAD to \
$first_parent")"
382 case "$new_parents" in
384 test "a$1" = a-n
&& die
"$(eval_gettext "Refusing to squash a merge
: \
$sha1")"
387 author_script_content
=$
(get_author_ident_from_commit
$sha1)
388 eval "$author_script_content"
389 msg_content
="$(commit_message $sha1)"
390 # No point in merging the first parent, that's HEAD
391 new_parents
=${new_parents# $first_parent}
392 merge_args
="--no-log --no-ff"
393 if ! do_with_author output
eval \
394 git merge $
{gpg_sign_opt
:+$
(git rev-parse \
395 --sq-quote "$gpg_sign_opt")} \
396 $allow_rerere_autoupdate "$merge_args" \
398 -m "$(git rev-parse --sq-quote "$msg_content")" \
401 printf "%s\n" "$msg_content" > "$GIT_DIR"/MERGE_MSG
402 die_with_patch
$sha1 "$(eval_gettext "Error redoing merge \
$sha1")"
404 echo "$sha1 $(git rev-parse HEAD^0)" >> "$rewritten_list"
407 output
eval git cherry-pick
$allow_rerere_autoupdate \
408 $allow_empty_message \
409 ${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")} \
410 "$strategy_args" "$@" ||
411 die_with_patch
$sha1 "$(eval_gettext "Could not pick \
$sha1")"
418 this_nth_commit_message
() {
420 eval_gettext
"This is the commit message #\${n}:"
423 skip_nth_commit_message
() {
425 eval_gettext
"The commit message #\${n} will be skipped:"
428 update_squash_messages
() {
429 if test -f "$squash_msg"; then
430 mv "$squash_msg" "$squash_msg".bak ||
exit
432 -e "1s/^$comment_char[^0-9]*\([0-9][0-9]*\).*/\1/p" \
433 -e "q" < "$squash_msg".bak
)+1))
435 printf '%s\n' "$comment_char $(eval_ngettext \
436 "This is a combination of \
$count commit.
" \
437 "This is a combination of \
$count commits.
" \
439 sed -e 1d
-e '2,/^./{
441 }' <"$squash_msg".bak
444 commit_message HEAD
>"$fixup_msg" ||
445 die
"$(eval_gettext "Cannot
write \
$fixup_msg")"
448 printf '%s\n' "$comment_char $(gettext "This is a combination of
2 commits.
")"
449 printf '%s\n' "$comment_char $(gettext "This is the
1st commit message
:")"
458 printf '%s\n' "$comment_char $(this_nth_commit_message $count)"
464 printf '%s\n' "$comment_char $(skip_nth_commit_message $count)"
466 # Change the space after the comment character to TAB:
467 commit_message
$2 | git stripspace
--comment-lines |
sed -e 's/ / /'
472 peek_next_command
() {
473 git stripspace
--strip-comments <"$todo" |
sed -n -e 's/ .*//p' -e q
476 # A squash/fixup has failed. Prepare the long version of the squash
477 # commit message, then die_with_patch. This code path requires the
478 # user to edit the combined commit message for all commits that have
479 # been squashed/fixedup so far. So also erase the old squash
480 # messages, effectively causing the combined commit to be used as the
481 # new basis for any further squash/fixups. Args: sha1 rest
482 die_failed_squash
() {
485 mv "$squash_msg" "$msg" ||
exit
487 cp "$msg" "$GIT_DIR"/MERGE_MSG ||
exit
489 warn
"$(eval_gettext "Could not apply \
$sha1... \
$rest")"
490 die_with_patch
$sha1 ""
493 flush_rewritten_pending
() {
494 test -s "$rewritten_pending" ||
return
495 newsha1
="$(git rev-parse HEAD^0)"
496 sed "s/$/ $newsha1/" < "$rewritten_pending" >> "$rewritten_list"
497 rm -f "$rewritten_pending"
500 record_in_rewritten
() {
501 oldsha1
="$(git rev-parse $1)"
502 echo "$oldsha1" >> "$rewritten_pending"
504 case "$(peek_next_command)" in
508 flush_rewritten_pending
516 if test "$(git rev-parse HEAD)" = "$squash_onto"
518 # Set the correct commit message and author info on the
519 # sentinel root before cherry-picking the original changes
520 # without committing (-n). Finally, update the sentinel again
521 # to include these changes. If the cherry-pick results in a
522 # conflict, this means our behaviour is similar to a standard
523 # failed cherry-pick during rebase, with a dirty index to
524 # resolve before manually running git commit --amend then git
526 git commit
--allow-empty --allow-empty-message --amend \
527 --no-post-rewrite -n -q -C $sha1 $signoff &&
529 git commit
--allow-empty --allow-empty-message \
530 --amend --no-post-rewrite -n -q -C $sha1 $signoff \
531 ${gpg_sign_opt:+"$gpg_sign_opt"} ||
532 die_with_patch
$sha1 "$(eval_gettext "Could not apply \
$sha1... \
$rest")"
535 die_with_patch
$sha1 "$(eval_gettext "Could not apply \
$sha1... \
$rest")"
540 rm -f "$msg" "$author_script" "$amend" "$state_dir"/stopped-sha ||
exit
541 read -r command sha1 rest
< "$todo"
543 "$comment_char"*|
''|noop|drop|d
)
547 # Work around CR left by "read" (e.g. with Git for Windows' Bash).
551 comment_for_reflog pick
554 do_pick
$sha1 "$rest"
555 record_in_rewritten
$sha1
558 comment_for_reflog reword
561 do_pick
$sha1 "$rest"
562 git commit
--amend --no-post-rewrite ${gpg_sign_opt:+"$gpg_sign_opt"} \
563 $allow_empty_message ||
{
564 warn
"$(eval_gettext "\
565 Could not amend commit after successfully picking \
$sha1... \
$rest
566 This is most likely due to an empty commit message
, or the pre-commit hook
567 failed. If the pre-commit hook failed
, you may need to resolve the issue before
568 you are able to reword the commit.
")"
569 exit_with_patch
$sha1 1
571 record_in_rewritten
$sha1
574 comment_for_reflog edit
577 do_pick
$sha1 "$rest"
578 sha1_abbrev
=$
(git rev-parse
--short $sha1)
579 warn
"$(eval_gettext "Stopped
at \
$sha1_abbrev... \
$rest")"
580 exit_with_patch
$sha1 0
591 comment_for_reflog
$squash_style
593 test -f "$done" && has_action
"$done" ||
594 die
"$(eval_gettext "Cannot
'\$squash_style' without a previous commit
")"
597 update_squash_messages
$squash_style $sha1
598 author_script_content
=$
(get_author_ident_from_commit HEAD
)
599 echo "$author_script_content" > "$author_script"
600 eval "$author_script_content"
601 if ! pick_one
-n $sha1
603 git rev-parse
--verify HEAD
>"$amend"
604 die_failed_squash
$sha1 "$rest"
606 case "$(peek_next_command)" in
608 # This is an intermediate commit; its message will only be
609 # used in case of trouble. So use the long version:
610 do_with_author output git commit
--amend --no-verify -F "$squash_msg" \
611 ${gpg_sign_opt:+"$gpg_sign_opt"} $allow_empty_message ||
612 die_failed_squash
$sha1 "$rest"
615 # This is the final command of this squash/fixup group
616 if test -f "$fixup_msg"
618 do_with_author git commit
--amend --no-verify -F "$fixup_msg" \
619 ${gpg_sign_opt:+"$gpg_sign_opt"} $allow_empty_message ||
620 die_failed_squash
$sha1 "$rest"
622 cp "$squash_msg" "$GIT_DIR"/SQUASH_MSG ||
exit
623 rm -f "$GIT_DIR"/MERGE_MSG
624 do_with_author git commit
--amend --no-verify -F "$GIT_DIR"/SQUASH_MSG
-e \
625 ${gpg_sign_opt:+"$gpg_sign_opt"} $allow_empty_message ||
626 die_failed_squash
$sha1 "$rest"
628 rm -f "$squash_msg" "$fixup_msg"
631 record_in_rewritten
$sha1
634 read -r command rest
< "$todo"
636 eval_gettextln
"Executing: \$rest"
637 "${SHELL:-@SHELL_PATH@}" -c "$rest" # Actual execution
639 # Run in subshell because require_clean_work_tree can die.
641 (require_clean_work_tree
"rebase" 2>/dev
/null
) || dirty
=t
642 if test "$status" -ne 0
644 warn
"$(eval_gettext "Execution failed
: \
$rest")"
646 warn
"$(gettext "and made changes to the index and
/or the working tree
")"
649 You can fix the problem
, and
then run
651 git rebase
--continue")"
653 if test $status -eq 127 # command not found
658 elif test "$dirty" = t
660 # TRANSLATORS: after these lines is a command to be issued by the user
661 warn
"$(eval_gettext "\
662 Execution succeeded
: \
$rest
663 but left changes to the index and
/or the working tree
664 Commit or stash your changes
, and
then run
666 git rebase
--continue")"
672 warn
"$(eval_gettext "Unknown
command: \
$command \
$sha1 \
$rest")"
673 fixtodo
="$(gettext "Please fix this using
'git rebase --edit-todo'.
")"
674 if git rev-parse
--verify -q "$sha1" >/dev
/null
676 die_with_patch
$sha1 "$fixtodo"
682 test -s "$todo" && return
684 comment_for_reflog finish
&&
685 newhead
=$
(git rev-parse HEAD
) &&
688 message
="$GIT_REFLOG_ACTION: $head_name onto $onto" &&
689 git update-ref
-m "$message" $head_name $newhead $orig_head &&
691 -m "$GIT_REFLOG_ACTION: returning to $head_name" \
695 test ! -f "$state_dir"/verbose ||
696 git diff-tree
--stat $orig_head..HEAD
699 test -s "$rewritten_list" &&
700 git notes copy
--for-rewrite=rebase
< "$rewritten_list" ||
701 true
# we don't care if this copying failed
703 hook
="$(git rev-parse --git-path hooks/post-rewrite)"
704 if test -x "$hook" && test -s "$rewritten_list"; then
705 "$hook" rebase
< "$rewritten_list"
706 true
# we don't care if this hook failed
708 warn
"$(eval_gettext "Successfully rebased and updated \
$head_name.
")"
710 return 1 # not failure; just to break the do_rest loop
713 # can only return 0, when the infinite loop breaks
722 git rebase--helper
--expand-ids
725 collapse_todo_ids
() {
726 git rebase--helper
--shorten-ids
729 # Switch to the branch in $into and notify it in the reflog
731 GIT_REFLOG_ACTION
="$GIT_REFLOG_ACTION: checkout $onto_name"
732 output git checkout
$onto || die_abort
"$(gettext "could not detach HEAD
")"
733 git update-ref ORIG_HEAD
$orig_head
736 get_missing_commit_check_level
() {
737 check_level
=$
(git config
--get rebase.missingCommitsCheck
)
738 check_level
=${check_level:-ignore}
739 # Don't be case sensitive
740 printf '%s' "$check_level" |
tr 'A-Z' 'a-z'
743 # Initiate an action. If the cannot be any
744 # further action it may exec a command
745 # or exit and not return.
747 # TODO: Consider a cleaner return model so it
748 # never exits and always return 0 if process
751 # Parameter 1 is the action to initiate.
753 # Returns 0 if the action was able to complete
754 # and if 1 if further processing is required.
758 if test ! -d "$rewritten"
760 exec git rebase--helper
${force_rebase:+--no-ff} $allow_empty_message \
763 # do we have anything to commit?
764 if git diff-index
--cached --quiet HEAD
--
766 # Nothing to commit -- skip this commit
768 test ! -f "$GIT_DIR"/CHERRY_PICK_HEAD ||
769 rm "$GIT_DIR"/CHERRY_PICK_HEAD ||
770 die
"$(gettext "Could not remove CHERRY_PICK_HEAD
")"
772 if ! test -f "$author_script"
774 gpg_sign_opt_quoted
=${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")}
775 die
"$(eval_gettext "\
776 You have staged changes
in your working tree.
777 If these changes are meant to be
778 squashed into the previous commit
, run
:
780 git commit
--amend \
$gpg_sign_opt_quoted
782 If they are meant to go into a new commit
, run
:
784 git commit \
$gpg_sign_opt_quoted
786 In both cases
, once you
're done, continue with:
788 git rebase --continue
791 . "$author_script" ||
792 die "$(gettext "Error trying to find the author identity to amend commit")"
795 current_head=$(git rev-parse --verify HEAD)
796 test "$current_head" = $(cat "$amend") ||
798 You have uncommitted changes in your working tree. Please commit them
799 first and then run 'git rebase
--continue' again.")"
800 do_with_author git commit --amend --no-verify -F "$msg" -e \
801 ${gpg_sign_opt:+"$gpg_sign_opt"} $allow_empty_message ||
802 die "$(gettext "Could not commit staged changes.")"
804 do_with_author git commit --no-verify -F "$msg" -e \
805 ${gpg_sign_opt:+"$gpg_sign_opt"} $allow_empty_message ||
806 die "$(gettext "Could not commit staged changes.")"
810 if test -r "$state_dir"/stopped-sha
812 record_in_rewritten "$(cat "$state_dir"/stopped-sha)"
815 require_clean_work_tree "rebase"
822 if test ! -d "$rewritten"
824 exec git rebase--helper ${force_rebase:+--no-ff} $allow_empty_message \
831 git stripspace --strip-comments <"$todo" >"$todo".new
832 mv -f "$todo".new "$todo"
836 You are editing the todo file of an ongoing interactive rebase.
837 To continue rebase after editing, run:
838 git rebase --continue
840 " | git stripspace --comment-lines >>"$todo"
842 git_sequence_editor "$todo" ||
843 die "$(gettext "Could not execute editor")"
849 exec git show REBASE_HEAD --
857 setup_reflog_action () {
858 comment_for_reflog start
860 if test ! -z "$switch_to"
862 GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $switch_to"
863 output git checkout "$switch_to" -- ||
864 die "$(eval_gettext "Could not checkout \$switch_to")"
866 comment_for_reflog start
870 init_basic_state () {
871 orig_head=$(git rev-parse --verify HEAD) || die "$(gettext "No HEAD?")"
872 mkdir -p "$state_dir" || die "$(eval_gettext "Could not create temporary \$state_dir")"
873 rm -f "$(git rev-parse --git-path REBASE_HEAD)"
875 : > "$state_dir"/interactive || die "$(gettext "Could not mark as interactive")"
879 init_revisions_and_shortrevisions () {
880 shorthead=$(git rev-parse --short $orig_head)
881 shortonto=$(git rev-parse --short $onto)
882 if test -z "$rebase_root"
883 # this is now equivalent to ! -z "$upstream"
885 shortupstream=$(git rev-parse --short $upstream)
886 revisions=$upstream...$orig_head
887 shortrevisions=$shortupstream..$shorthead
889 revisions=$onto...$orig_head
890 shortrevisions=$shorthead
895 test -s "$todo" || echo noop >> "$todo"
896 test -z "$autosquash" || git rebase--helper --rearrange-squash || exit
897 test -n "$cmd" && git rebase--helper --add-exec-commands "$cmd"
899 todocount=$(git stripspace --strip-comments <"$todo" | wc -l)
900 todocount=${todocount##* }
904 $comment_char $(eval_ngettext \
905 "Rebase \$shortrevisions onto \$shortonto (\$todocount command)" \
906 "Rebase \$shortrevisions onto \$shortonto (\$todocount commands)" \
911 However, if you remove everything, the rebase will be aborted.
913 " | git stripspace --comment-lines >>"$todo"
915 if test -z "$keep_empty"
917 printf '%s
\n' "$comment_char $(gettext "Note that empty commits are commented out")" >>"$todo"
921 has_action "$todo" ||
924 cp "$todo" "$todo".backup
926 git_sequence_editor "$todo" ||
927 die_abort "$(gettext "Could not execute editor")"
929 has_action "$todo" ||
932 git rebase--helper --check-todo-list || {
940 test -d "$rewritten" || test -n "$force_rebase" ||
941 onto="$(git rebase--helper --skip-unnecessary-picks)" ||
942 die "Could not skip unnecessary pick commands"
945 if test -z "$rebase_root" && test ! -d "$rewritten"
947 require_clean_work_tree "rebase"
948 exec git rebase--helper ${force_rebase:+--no-ff} $allow_empty_message \
954 git_rebase__interactive () {
955 initiate_action "$action"
957 if test $ret = 0; then
964 init_revisions_and_shortrevisions
966 git rebase--helper --make-script ${keep_empty:+--keep-empty} \
967 $revisions ${restrict_revision+^$restrict_revision} >"$todo" ||
968 die "$(gettext "Could not generate todo list")"
973 git_rebase__interactive__preserve_merges () {
974 initiate_action "$action"
976 if test $ret = 0; then
983 if test -z "$rebase_root"
985 mkdir "$rewritten" &&
986 for c in $(git merge-base --all $orig_head $upstream)
988 echo $onto > "$rewritten"/$c ||
989 die "$(gettext "Could not init rewritten commits")"
992 mkdir "$rewritten" &&
993 echo $onto > "$rewritten"/root ||
994 die "$(gettext "Could not init rewritten commits")"
997 init_revisions_and_shortrevisions
999 format=$(git config --get rebase.instructionFormat)
1000 # the 'rev-list .. |
sed' requires %m to parse; the instruction requires %H to parse
1001 git rev-list --format="%m%H ${format:-%s}" \
1002 --reverse --left-right --topo-order \
1003 $revisions ${restrict_revision+^$restrict_revision} | \
1005 while read -r sha1 rest
1007 if test -z "$keep_empty" && is_empty_commit $sha1 && ! is_merge_commit $sha1
1009 comment_out="$comment_char "
1014 if test -z "$rebase_root"
1017 for p in $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)
1019 if test -f "$rewritten"/$p
1027 if test f = "$preserve"
1029 touch "$rewritten"/$sha1
1030 printf '%s
\n' "${comment_out}pick $sha1 $rest" >>"$todo"
1034 # Watch for commits that been dropped by --cherry-pick
1036 # Save all non-cherry-picked changes
1037 git rev-list $revisions --left-right --cherry-pick | \
1038 sed -n "s/^>//p" > "$state_dir"/not-cherry-picks
1039 # Now all commits and note which ones are missing in
1040 # not-cherry-picks and hence being dropped
1041 git rev-list $revisions |
1044 if test -f "$rewritten"/$rev &&
1045 ! sane_grep "$rev" "$state_dir"/not-cherry-picks >/dev/null
1047 # Use -f2 because if rev-list is telling us this commit is
1048 # not worthwhile, we don't want to track its multiple heads
,
1049 # just the history of its first-parent for others that will
1050 # be rebasing on top of it
1051 git rev-list
--parents -1 $rev | cut
-d' ' -s -f2 > "$dropped"/$rev
1052 sha1
=$
(git rev-list
-1 $rev)
1053 sane_grep
-v "^[a-z][a-z]* $sha1" <"$todo" > "${todo}2" ; mv "${todo}2" "$todo"
1054 rm "$rewritten"/$rev